In number theory and computer science, the **partition problem**, or **number partitioning**,^{[1]} is the task of deciding whether a given multiset *S* of positive integers can be partitioned into two subsets *S*_{1} and *S*_{2} such that the sum of the numbers in *S*_{1} equals the sum of the numbers in *S*_{2}. Although the partition problem is NP-complete, there is a pseudo-polynomial time dynamic programming solution, and there are heuristics that solve the problem in many instances, either optimally or approximately. For this reason, it has been called "the easiest hard problem".^{[2]}^{[3]}

There is an optimization version of the partition problem, which is to partition the multiset *S* into two subsets *S*_{1}, *S*_{2} such that the difference between the sum of elements in *S*_{1} and the sum of elements in *S*_{2} is minimized. The optimization version is NP-hard, but can be solved efficiently in practice.^{[4]}

The partition problem is a special case of two related problems:

- In the subset sum problem, the goal is to find a subset of
*S*whose sum is a certain target number*T*given as input (the partition problem is the special case in which*T*is half the sum of*S*). - In multiway number partitioning, there is an integer parameter
*k*, and the goal is to decide whether*S*can be partitioned into*k*subsets of equal sum (the partition problem is the special case in which*k*= 2).

However, it is quite different to the 3-partition problem: in that problem, the number of subsets is not fixed in advance – it should be |*S*|/3, where each subset must have exactly 3 elements. 3-partition is much harder than partition – it has no pseudo-polynomial time algorithm unless **P = NP**.^{[5]}

Given *S* = {3,1,1,2,2,1}, a valid solution to the partition problem is the two sets *S*_{1} = {1,1,1,2} and *S*_{2} = {2,3}. Both sets sum to 5, and they partition *S*. Note that this solution is not unique. *S*_{1} = {3,1,1} and *S*_{2} = {2,2,1} is another solution.

Not every multiset of positive integers has a partition into two subsets with equal sum. An example of such a set is *S* = {2,5}.

The partition problem is NP hard. This can be proved by reduction from the subset sum problem.^{[6]} An instance of SubsetSum consists of a set *S* of positive integers and a target sum *T*; the goal is to decide if there is a subset of *S* with sum exactly *T*.

Given such an instance, construct an instance of Partition in which the input set contains the original set plus two elements: *z*_{1} and *z*_{2}, with *z*_{1} = sum(S) and *z*_{2} = 2*T*. The sum of this input set is sum(*S*) + *z*_{1} + *z*_{2} = 2 sum(*S*) + 2*T*, so the target sum for Partition is sum(*S*) + *T*.

- Suppose there exists a solution
*S*′ to the SubsetSum instance. Then sum(*S*′) =*T*, so sum(S′ z_1) = sum(*S*) +*T*, so*S*′ z_1 is a solution to the Partition instance. - Conversely, suppose there exists a solution
*S*′′ to the Partition instance. Then,*S*′′ must contain either*z*_{1}or*z*_{2}, but not both, since their sum is more than sum(*S*) +*T*. If S'' contains*z*_{1}, then it must contain elements from S with a sum of exactly*T*, so S'' minus*z*_{1}is a solution to the SubsetSum instance. If S'' contains*z*_{2}, then it must contain elements from S with a sum of exactly sum(*S*) −*T*, so the other objects in*S*are a solution to the SubsetSum instance.

As mentioned above, the partition problem is a special case of multiway-partitioning and of subset-sum. Therefore, it can be solved by algorithms developed for each of these problems. Algorithms developed for multiway number partitioning include:

**Greedy number partitioning**– loops over the numbers, and puts each number in the set whose current sum is smallest. If the numbers are not sorted, then the runtime is O(*n*) and the approximation ratio is at most**3/2**("approximation ratio" means the larger sum in the algorithm output, divided by the larger sum in an optimal partition). Sorting the numbers increases the runtime to O(*n*log*n*) and improves the approximation ratio to**7/6.**If the numbers are distributed uniformly in [0,1], then the approximation ratio is at most almost surely, and in expectation.**Largest Differencing Method**(also called the**Karmarkar–Karp algorithm**) sorts the numbers in descending order and repeatedly replaces numbers by their differences. The runtime complexity is O(*n*log*n*). In the worst case, its approximation ratio is similar – at most**7/6**. However, in the average case it performs much better than the greedy algorithm: when numbers are distributed uniformly in [0,1], its approximation ratio is at most in expectation. It also performs better in simulation experiments.- The
**Multifit algorithm**uses binary search combined with an algorithm for bin packing. In the worst case, its approximation ratio is**8/7**. - The subset sum problem has an
**FPTAS**which can be used for the partition problem as well, by setting the target sum to sum(*S*)/2.

There are exact algorithms, that always find the optimal partition. Since the problem is NP-hard, such algorithms might take exponential time in general, but may be practically usable in certain cases. Algorithms developed for multiway number partitioning include:

- The pseudopolynomial time number partitioning takes memory, where m is the largest number in the input.
- The
**Complete Greedy Algorithm (CGA)**considers all partitions by constructing a binary tree. Each level in the tree corresponds to an input number, where the root corresponds to the largest number, the level below to the next-largest number, etc. Each branch corresponds to a different set in which the current number can be put. Traversing the tree in depth-first order requires only space, but might take time. The runtime can be improved by using a greedy heuristic: in each level, develop first the branch in which the current number is put in the set with the smallest sum. This algorithm finds first the solution found by greedy number partitioning, but then proceeds to look for better solutions. Some variations of this idea*are*fully polynomial-time approximation schemes for the subset-sum problem, and hence for the partition problem as well.^{[7]}^{[8]} - The
**Complete Karmarkar-Karp algorithm (CKK)**considers all partitions by constructing a binary tree. Each level corresponds to a pair of numbers. The left branch corresponds to putting them in different subsets (i.e., replacing them by their difference), and the right branch corresponds to putting them in the same subset (i.e., replacing them by their sum). This algorithm finds first the solution found by the largest differencing method, but then proceeds to find better solutions. It runs substantially faster than CGA on random instances. Its advantage is much larger when an equal partition exists, and can be of several orders of magnitude. In practice, problems of arbitrary size can be solved by CKK if the numbers have at most 12 significant digits.^{[9]}CKK can also run as an anytime algorithm: it finds the KK solution first, and then finds progressively better solutions as time allows (possibly requiring exponential time to reach optimality, for the worst instances).^{[1]}It requires space, but in the worst case might take time.

Algorithms developed for subset sum include:

**Horowitz and Sanhi**– runs in time , but requires space.**Schroeppel and Shamir**– runs in time , and requires much less space – .**Howgrave-Graham and Joux**– runs in time , but it is a randomized algorithm that only solves the decision problem (not the optimization problem).

Sets with only one, or no partitions tend to be hardest (or most expensive) to solve compared to their input sizes. When the values are small compared to the size of the set, perfect partitions are more likely. The problem is known to undergo a "phase transition"; being likely for some sets and unlikely for others. If m is the number of bits needed to express any number in the set and n is the size of the set then tends to have many solutions and tends to have few or no solutions. As n and m get larger, the probability of a perfect partition goes to 1 or 0 respectively. This was originally argued based on empirical evidence by Gent and Walsh,^{[10]} then using methods from statistical physics by Mertens,^{[11]}^{[12]} and later proved by Borgs, Chayes, and Pittel.^{[13]}

A related problem, somewhat similar to the Birthday paradox, is that of determining the size of the input set so that we have a probability of one half that there is a solution, under the assumption that each element in the set is randomly selected with uniform distribution between 1 and some given value. The solution to this problem can be counter-intuitive, like the birthday paradox.

**Equal-cardinality partition** is a variant in which both parts should have an equal number of items, in addition to having an equal sum. This variant is NP-hard too.^{[5]}^{: SP12 } *Proof*. Given a standard Partition instance with some *n* numbers, construct an Equal-Cardinality-Partition instance by adding *n* zeros. Clearly, the new instance has an equal-cardinality equal-sum partition iff the original instance has an equal-sum partition. See also **Balanced number partitioning**.

**Distinct partition** is a variant in which all input integers are distinct. This variant is NP-hard too.^{[citation needed]}

**Product partition** is the problem of partitioning a set of integers into two sets with the same *product* (rather than the same sum). This problem is strongly NP-hard.^{[14]}

Kovalyov and Pesch^{[15]} discuss a generic approach to proving NP-hardness of partition-type problems.

One application of the partition problem is for manipulation of elections. Suppose there are three candidates (A, B and C). A single candidate should be elected using a voting rule based on scoring, e.g. the veto rule (each voter vetoes a single candidate and the candidate with the fewest vetoes wins). If a coalition wants to ensure that C is elected, they should partition their votes among A and B so as to maximize the smallest number of vetoes each of them gets. If the votes are weighted, then the problem can be reduced to the partition problem, and thus it can be solved efficiently using CKK. The same is true for any other voting rule that is based on scoring.^{[16]}